Unit de15r_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTDE16_p;

procedure de15r(F :Proc_F_DE; M :Integer; var JSTART :Integer;
                HMIN :Real; EPS :Real; P :Real; var YX :Array of Real;
                var X :Real; var H :Real; var BUL :Boolean;
                var XP :Real; var YP :Array of Real;
                var DY :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real;
                var R4 :Array of Real; var IERR :Integer);

implementation

procedure de15r(F :Proc_F_DE; M :Integer; var JSTART :Integer;
                HMIN :Real; EPS :Real; P :Real; var YX :Array of Real;
                var X :Real; var H :Real; var BUL :Boolean;
                var XP :Real; var YP :Array of Real;
                var DY :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real;
                var R4 :Array of Real; var IERR :Integer);
var
I :Integer;
EPS1,HR,HR1,Z :Real;
BULH,BULHM :Boolean;
ALP :Array [0..4] of Real;
MU :Array [0..13] of Real;
MU1 :Array [0..2] of Real;
Q :Array [0..4] of Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110;
begin
{   DATA  FORTRAN  }
MU1[0] := 0.25e0;
MU1[1] := 0.375e0;
MU1[2] := 0.9230769230769230e0;
MU[0] := 0.25e0;
MU[1] := 0.09375e0;
MU[2] := 0.8793809740555302e0;
MU[3] := -3.726708074534161e0;
MU[4] := 3.776397515527950e0;
MU[5] := 2.032407407407407e0;
MU[6] := -3.936218678815489e0;
MU[7] := 3.529552811413499e0;
MU[8] := -0.1013067977460736e0;
MU[9] := -0.2962962962962962e0;
MU[10] := 6.75e0;
MU[11] := -4.663157894736842e0;
MU[12] := 1.528782894736842e0;
MU[13] := -0.928125e0;
ALP[0] := 0.2341654703966947e0;
ALP[1] := 1.025398270368684e0;
ALP[2] := 0.5061314903420167e0;
ALP[3] := -0.3556388081649802e0;
ALP[4] := 0.07184622387171318e0;
Q[0] := 0.07638888888888889e0;
Q[1] := -0.8233918128654970e0;
Q[2] := -0.8029970760233918e0;
Q[3] := 0.55e0;
Q[4] := 0.03636363636363636e0;
IERR := 0;
BULHM := False;
BULH := True;
EPS1 := EPS/32.0;
if ( JSTART =  -1 ) 
 then goto _20;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_10:
 end;
XP := X;
F(XP,YP,DY,M);
_20:
HR := MU1[0]*H;
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1] + HR*DY[I-1];
_30:
 end;
F(XP + HR,YX,R1,M);
HR := MU[1]*H;
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1] + HR*(DY[I-1] + 3.0*R1[I-1]);
_40:
 end;
F(XP + MU1[1]*H,YX,R2,M);
HR := MU[2]*H;
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1] + HR*(DY[I-1] + MU[3]*R1[I-1] + MU[4]*R2[I-1]);
_50:
 end;
F(XP + MU1[2]*H,YX,R3,M);
HR := MU[5]*H;
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1] + HR*(DY[I-1] + MU[6]*R1[I-1] + MU[7]*R2[I-1] +
    MU[8]*R3[I-1]);
_60:
 end;
F(XP + H,YX,R4,M);
HR := -MU[9]*H;
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1] + HR*(-DY[I-1] + MU[10]*R1[I-1] + MU[11]*R2[I-1]
    + MU[12]*R3[I-1] + MU[13]*R4[I-1]);
_70:
 end;
F(XP + 0.5*H,YX,R1,M);
HR := ALP[2]*H;
HR1 := H*Q[4];
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1] + HR*(ALP[0]*DY[I-1] + ALP[1]*R2[I-1] + R3[I-1] +
    ALP[3]*R4[I-1] + ALP[4]*R1[I-1]);
  Z := HR1*(Q[0]*DY[I-1] + Q[1]*R2[I-1] + Q[2]*R3[I-1] + Q[3]*R4[I-1]
    + R1[I-1]);
  if ( Abs(YX[I-1]) >  P ) 
   then Z := Z/YX[I-1];
  Z := Abs(Z);
  if ( Z <=  EPS ) 
   then goto _80;
  if ( BULHM ) 
   then goto _100;
  H := H*0.5;
  BUL := False;
  BULH := False;
  if ( Abs(H) >  Abs(HMIN) ) 
   then goto _20;
  H := Sign(HMIN,H);
  BULHM := True;
  goto _20;
_80:
  if ( Z <  EPS1 ) 
   then goto _90;
  BULH := False;
_90:
 end;
X := XP + H;
if ( BULH ) 
 then H := H + H;
goto _110;
_100:
IERR := 65;
UTDE16(IERR,15);
_110:
JSTART := 1;
end;

end.
